<?php
/**
 * @package Sj Zoo Categories Accordion
 * @version 2.5
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 *
 */
defined('_JEXEC') or die;
class ZooCategoriesAccordionReader extends SjReader{
    public function getList(&$params){
        $list =array();			
        $category_ids = $this->zoo->getPublishedCategories($params);			
        if(!empty($category_ids)){
            foreach($category_ids as $cid){
                $category = $this->zoo->getCategory($cid);					
                $category->link = JRoute::_('index.php?option=com_zoo&task=category&category_id='.$cid);
                if (!isset($category->image_extracted)){
                    $category_images = YTools::extractImages($category->description);
        			$category->image_extracted = true;
                }							
                if (!isset($category->image) && count($category_images)){					
                    foreach ($category_images as $i => $image_url) {
                        if (YTools::isUrl($image_url) || file_exists($image_url)){
            				$category->image = $image_url;
            				break;
        				}
                    }
        		}
                $category->child= $this->itemsForCategory($cid, $params);					 					
    			$list[$cid]=$category;					
    		}           
		}
        if(!empty($list)){
            switch ($params['cat_order_by']){
              case '0':
                usort($list, create_function('$a, $b', 'return strcmp($a->title, $b->title);'));
                break;
              case '1':
                usort($list, create_function('$a, $b', 'return strcmp($a->ordering, $b->ordering);'));
                break;
              case '2':
                shuffle($list);
                break;
            }
        }        
        //var_dump($list); die("ancncncncnc");		
		return $list;
    }
		
	private function itemsForCategory($category_ids, $params){
		$items=array();	
		$list_item = $this->zoo->getCategoryItems($category_ids, $params);				
		if(!empty($list_item)) {			
			$arrcustom_url=array();
			$arrcustom_url = $this->_getCustomUrl($params['custom_url']);
			foreach($list_item as $key => $item){													
                $this->zoo->getItemImage($item,$params);                		
    			$this->zoo->getItemDescription($item,$params);						
    			YTools::extractImages($item->description);	
    			if ((int)$params['item_desc_keephtml']==0){
  					$item->description = strip_tags($item->description);
    			}
    			if(array_key_exists($item->id, $arrcustom_url)){
    				$item->link = $arrcustom_url[$item->id];					
    			} else {
    				$item->link = $this->zoo->getItemUrl($item);
    			}
    			if(isset($item->author_id)) {	
    				$author = &JFactory::getUser($item->author_id);
    				$item->creater = $author->get('name'); 
    			}
			$items[]=$item; 
            }
        }		
		return $items;
    }				
	private function _getCustomUrl($custom_url) {
		$arrUrl = array();
		$tmp = explode("\n", trim($custom_url));
		foreach( $tmp as $strTmp){
			$pos = strpos($strTmp, ":");
			if($pos >=0){
				$tmpKey = substr($strTmp, 0, $pos);
				$key = trim($tmpKey);
				$tmpLink = substr($strTmp, $pos+1, strlen($strTmp)-$pos);
				$haveHttp =  strpos(trim($tmpLink), "http://");
				if($haveHttp<0 || ($haveHttp !== false) ){
					$link = trim($tmpLink);
				}else{
					$link = "http://" . trim($tmpLink);
				}
				$arrUrl[$key] = $link;
			}
		}
		return $arrUrl;
	}	
}

?>